import * as i0 from '@angular/core';
import { EventEmitter, Directive, Input, Output, HostListener, NgModule } from '@angular/core';
import * as d3 from 'd3';

class D3GlobalConstants {
}
D3GlobalConstants.metaColorOpacity = 0.5;
D3GlobalConstants.metaColors = [
    'rgba(202,88,183,' + D3GlobalConstants.metaColorOpacity + ')',
    'rgba(251,238,62,' + D3GlobalConstants.metaColorOpacity + ')',
    'rgba(86,180,233,' + D3GlobalConstants.metaColorOpacity + ')',
    'rgba(144,65,0,' + D3GlobalConstants.metaColorOpacity + ')',
    'rgba(0,60,60,' + D3GlobalConstants.metaColorOpacity + ')',
];
function log10(val) {
    return Math.log(val) / Math.LN10;
}
/*
export function colorlegend(target, scale, type, options) {
  var scaleTypes = ['linear', 'quantile', 'ordinal'],
    found = false,
    opts = options || {},
    boxWidth = opts.boxWidth || 20, // width of each box (int)
    boxHeight = opts.boxHeight || 20, // height of each box (int)
    title = opts.title || null, // draw title (string)
    fill = opts.fill || false, // fill the element (boolean)
    linearBoxes = opts.linearBoxes || 9, // number of boxes for linear scales (int)
    htmlElement = target, //document.getElementById(target.substring(0, 1) === '#' ? target.substring(1, target.length) : target)  // target container element - strip the prefix #
    w = htmlElement.offsetWidth, // width of container element
    h = htmlElement.offsetHeight, // height of container element
    colors = [],
    padding = [2, 4, 10, 4], // top, right, bottom, left
    boxSpacing = type === 'ordinal' ? 3 : 0, // spacing between boxes
    titlePadding = title ? 11 : 0,
    domain = scale.domain(),
    range = scale.range(),
    i = 0;

  // check for valid input - 'quantize' not included
  for (i = 0; i < scaleTypes.length; i++) {
    if (scaleTypes[i] === type) {
      found = true;
      break;
    }
  }
  if (!found) {
    throw new Error('Scale type, ' + type + ', is not suported.');
  }

  // setup the colors to use
  if (type === 'quantile') {
    colors = range;
  } else if (type === 'ordinal') {
    for (i = 0; i < domain.length; i++) {
      colors[i] = range[i];
    }
  } else if (type === 'linear') {
    var min = domain[0];
    var max = domain[domain.length - 1];
    for (i = 0; i <= linearBoxes; i++) {
      colors[i] = scale(min + i * ((max - min) / linearBoxes));
    }
  }
  // check the width and height and adjust if necessary to fit in the element
  // use the range if quantile
  if (
    fill ||
    w < (boxWidth + boxSpacing) * colors.length + padding[1] + padding[3]
  ) {
    boxWidth =
      (w - padding[1] - padding[3] - boxSpacing * colors.length) /
      colors.length;
  }
  if (fill || h < boxHeight + padding[0] + padding[2] + titlePadding) {
    boxHeight = h - padding[0] - padding[2] - titlePadding;
  }

  // set up the legend graphics context
  var legend = d3
    .select(target)
    .append('svg')
    .attr('width', w)
    .attr('height', h)
    .append('g')
    .attr('class', 'colorlegend')
    .attr('transform', 'translate(' + padding[3] + ',' + padding[0] + ')')
    .style('font-size', '11px')
    .style('fill', '#666');

  var legendBoxes = legend
    .selectAll('g.legend')
    .data(colors)
    .enter()
    .append('g');

  // value labels
  legendBoxes
    .append('text')
    .attr('class', 'colorlegend-labels')
    .attr('dy', '.71em')
    .attr('x', function (d, i) {
      return (
        i * (boxWidth + boxSpacing) + (type !== 'ordinal' ? boxWidth / 2 : 0)
      );
    })
    .attr('y', function () {
      return boxHeight + 2;
    })
    .style('text-anchor', function () {
      return type === 'ordinal' ? 'start' : 'middle';
    })
    .style('pointer-events', 'none')
    .text(function (d, i) {
      // show label for all ordinal values
      if (type === 'ordinal') {
        return domain[i];
      }
      // show only the first and last for others
      else {
        if (i === 0) {
          return domain[0].toPrecision(2);
        }
        if (i === colors.length - 1) {
          return domain[domain.length - 1].toPrecision(2);
        }
      }
    });

  // the colors, each color is drawn as a rectangle
  legendBoxes
    .append('rect')
    .attr('x', function (d, i) {
      return i * (boxWidth + boxSpacing);
    })
    .attr('width', boxWidth)
    .attr('height', boxHeight)
    .style('fill', function (d, i) {
      return colors[i];
    });

  // show a title in center of legend (bottom)
  if (title) {
    legend
      .append('text')
      .attr('class', 'colorlegend-title')
      .attr('x', colors.length * (boxWidth / 2))
      .attr('y', boxHeight + titlePadding)
      .attr('dy', '.71em')
      .style('text-anchor', 'middle')
      .style('pointer-events', 'none')
      .text(title);
  }

  return this;
}

var outputTSpan = function (
  el,
  line,
  idx,
  lineCnt,
  charEm,
  headerBtmPadEm,
  fill,
  fontFamily,
  fontSize,
  tAnchor,
  tAlign,
  domBaseline,
  cssClass,
  x,
  y
) {
  // shift lines down by index, and up by 1/2 line count, minus 1 line for title
  var dyVal = idx * charEm - lineCnt * 0.5 * charEm + charEm + headerBtmPadEm;
  d3.select(el)
    .append('tspan')
    .text(line)
    .attr('dy', dyVal + 'em') // y offset per line index
    .attr('x', x)
    .attr('y', 0)
    .style('fill', fill)
    .style('font-family', fontFamily)
    .style('font-size', fontSize)
    .style('text-anchor', tAnchor)
    .style('text-align', tAlign)
    .style('dominant-baseline', domBaseline)
    .attr('class', cssClass);
};

export function wrapText(
  text,
  el,
  boxWidth,
  charWidthPx,
  maxLines,
  charEm,
  headerBtmPadEm,
  fill,
  fontFamily,
  fontSize,
  tAnchor,
  tAlign,
  domBaseline,
  cssClass,
  x?,
  y?
) {
  var arr = text.split(' '); // array split by space
  if (!x) {
    x = 0;
  } // optional x value to shift text
  if (!y) {
    y = 0;
  } // optional y value to shift text
  if (arr !== undefined) {
    var linePxW = 0; // counting approximate pixel width- will only work well for monospaced font.  choose an average value on the low side.
    var linePxWNext = 0; // counting what the character count will be for i+1 words, to pre-determine how to wrap or hyphenate
    var ln = 0; // line count
    var outLines = [];
    var myLine = '';
    // split any hyphenated words that are longer than a line.
    for (var i = 0; i < arr.length; i++) {
      var undIdx = arr[i].indexOf('-');
      if (undIdx > 0) {
        var wordPxW = arr[i].length * charWidthPx;
        if (wordPxW >= boxWidth) {
          var firstPart = arr[i].substring(0, undIdx + 1);
          var lastPart = arr[i].substring(undIdx + 1);
          arr.splice(i, 1, firstPart, lastPart);
        }
      }
    }
    for (i = 0; i < arr.length; i++) {
      // get approximate px width of word arr[i]
      wordPxW = arr[i].length * charWidthPx;
      linePxW += wordPxW; // current pixel width of the line
      linePxWNext = linePxW;
      // width line will be, after adding the next word, if one exists
      if (arr[i + 1]) {
        linePxWNext = linePxWNext + 1 + arr[i + 1].length * charWidthPx;
      }
      myLine = myLine + ' ' + arr[i];
      // if we will exceed the max width in px, wrap the line.
      if (linePxWNext >= boxWidth) {
        // if word is too long, hyphenate here
        // if max lines exceeded, truncate and add ...
        // position text lines from center, offset + or -
        outLines.push(myLine);
        ln++; // increment the line
        linePxW = 0; // reset the line px count
        linePxWNext = 0; // reset the line px next count
        myLine = ''; // reset the line txt
      } else if (outLines.length && !arr[i + 1]) {
        // this is the last line, and we're already building the multi-line arr so go with it
        outLines.push(myLine);
      }
    }
    // generate the text lines using our line array
    if (outLines.length) {
      var outLinesTot = outLines.length;
      if (outLinesTot > maxLines) {
        outLinesTot = maxLines;
      }
      for (i = 0; i < outLines.length; i++) {
        if (i >= maxLines - 1 && outLines[i + 1]) {
          var toOutput = outLines[i] + '...'; // truncate
          outputTSpan(
            el,
            toOutput,
            i,
            outLinesTot,
            charEm,
            headerBtmPadEm,
            fill,
            fontFamily,
            fontSize,
            tAnchor,
            tAlign,
            domBaseline,
            cssClass,
            x,
            y
          );
          break;
        }
        outputTSpan(
          el,
          outLines[i],
          i,
          outLinesTot,
          charEm,
          headerBtmPadEm,
          fill,
          fontFamily,
          fontSize,
          tAnchor,
          tAlign,
          domBaseline,
          cssClass,
          x,
          y
        );
      }
    } else {
      outputTSpan(
        el,
        text,
        0,
        1,
        charEm,
        headerBtmPadEm,
        fill,
        fontFamily,
        fontSize,
        tAnchor,
        tAlign,
        domBaseline,
        cssClass,
        x,
        y
      );
    }
  }
}
*/

//Hard linked to app and library
class TwoWayPlotDirective {
    constructor(ele) {
        this.ele = ele;
        /**
         *@description This function will triggered when clicking a spot if the disableSelection is true and it will emit the itemId of the spot that is clicked
         */
        this.nextStateFn = new EventEmitter();
        this.twoWayPlotVersion = 'TWP v2.0';
        this.margin = { top: 20, right: 20, bottom: 75, left: 70 };
    }
    init() {
        this.axisOffset = 20;
        this.mainComp = d3.select(this.ele.nativeElement).append('div');
        this.tooltip = this.mainComp
            .append('div')
            .attr('class', 'd3-tip')
            .style('position', 'absolute')
            .style('z-index', '10')
            .style('visibility', 'hidden')
            .text('');
        this.svgExt = this.mainComp
            .append('svg')
            .attr('width', this.ele.nativeElement.parentElement.offsetWidth)
            .attr('height', this.ele.nativeElement.parentElement.offsetWidth);
        this.svgExt
            .append('rect')
            .attr('width', '100%')
            .attr('height', '100%')
            .style('fill', 'white');
        this.svg = this.svgExt
            .append('g')
            .attr('class', 'drawingRegion')
            .attr('transform', 'translate(' + this.margin.left + ',' + this.margin.top + ')');
        this.width =
            this.svgExt.attr('width') - this.margin.left - this.margin.right;
        this.height =
            this.svgExt.attr('height') - this.margin.top - this.margin.bottom;
        if (!this.disableSelection) {
            this.disableSelection = false;
        }
        this.x = d3.scaleLinear().range([0, this.width]);
        this.y = d3.scaleLinear().range([this.height, 0]);
        this.color = d3.scaleOrdinal().range(['black', 'red']);
        this.color.domain([false, true]);
        if (this.itemScale === 'log') {
            this.pSize = d3.scaleLog().base(2).range([3.5, 14]);
        }
        else {
            this.pSize = d3.scaleLinear().range([3.5, 14]);
        }
        this.xAxis = d3.axisBottom(this.x);
        this.yAxis = d3.axisLeft(this.y);
        var numTicks = Math.floor(this.width / this.numTicks);
        this.yAxis.ticks(numTicks);
        this.xAxis.ticks(numTicks);
        this.svg
            .append('g')
            .attr('class', 'x axis')
            .attr('transform', 'translate(0,' + (this.height + this.axisOffset) + ')')
            .append('text')
            .style('font-weight', 'bold')
            .style('font-size', '12px')
            .style('font-family', "'Helvetica Neue', Helvetica, Arial, sans-serif")
            .attr('class', 'label')
            .attr('x', this.width)
            .attr('y', -6)
            .style('text-anchor', 'end');
        this.svg
            .append('g')
            .attr('class', 'y axis')
            .append('text')
            .style('font-weight', 'bold')
            .style('font-size', '12px')
            .style('font-family', "'Helvetica Neue', Helvetica, Arial, sans-serif")
            .attr('class', 'label')
            .attr('transform', 'rotate(-90)')
            .attr('y', 6)
            .attr('dy', '.71em')
            .style('text-anchor', 'end');
        if (this.showXThreshold) {
            this.svg
                .append('line')
                .attr('class', 'x thr')
                .style('stroke-dasharray', '3, 3')
                .style('stroke', this.color(true))
                .style('stroke-opacity', 1e-6);
        }
        if (this.showYThreshold) {
            this.svg
                .append('line')
                .attr('class', 'y thr')
                .style('stroke-dasharray', '3, 3')
                .style('stroke', this.color(true))
                .style('stroke-opacity', 1e-6);
        }
        this.svgExt
            .append('text')
            .attr('x', '99%')
            .attr('y', '99%')
            .style('font-size', '10px')
            .style('font-weight', 'bold')
            .style('font-family', "'Helvetica Neue', Helvetica, Arial, sans-serif")
            .attr('class', 'label')
            .style('text-anchor', 'end')
            .text(this.twoWayPlotVersion +
            ', ' +
            '(c) Advaita Corporation ' +
            new Date().getFullYear());
    }
    ngOnChanges(changes) {
        if (!this.svgExt) {
            this.init();
        }
        if (changes.upType && changes.upType.currentValue) {
            this.updateData(this.data, this.correction, this.sigThr);
        }
        if (changes.selectedItem && changes.selectedItem.currentValue) {
            this.updateSelection(changes.selectedItem.currentValue, changes.selectedItem.previousValue);
        }
        if (changes.sigThr && changes.sigThr.currentValue) {
            this.updateData(this.data, this.correction, changes.sigThr.currentValue);
        }
        if (changes.data && changes.data.currentValue) {
            this.updateData(changes.data.currentValue, this.correction, this.sigThr);
        }
        if (changes.correction && changes.correction.currentValue != undefined) {
            this.updateData(this.data, changes.correction.currentValue, this.sigThr);
        }
    }
    onResize(event) {
        if (this.ele.nativeElement.parentElement.offsetWidth === 0) {
            return;
        }
        this.svgExt
            .attr('width', this.ele.nativeElement.parentElement.offsetWidth)
            .attr('height', this.ele.nativeElement.parentElement.offsetWidth);
        this.width =
            this.svgExt.attr('width') - this.margin.left - this.margin.right;
        this.height =
            this.svgExt.attr('height') - this.margin.top - this.margin.bottom;
        this.x.range([0, this.width]);
        this.y.range([this.height, 0]);
        var numTicks = Math.floor(this.width / this.numTicks);
        this.yAxis.ticks(numTicks);
        this.xAxis.ticks(numTicks);
        this.updateData(this.data, this.correction, this.sigThr);
    }
    updateSelection(newID, oldID) {
        if (oldID) {
            this.svg
                .select('#' + this.item + oldID)
                .transition()
                .duration(500)
                .style('fill', (d) => {
                return this.color(d[this.sigLabel + this.correction] < this.sigThr);
            })
                .style('fill-opacity', 0.7);
        }
        if (newID) {
            this.svg.select('#' + this.item + newID).raise();
            this.svg
                .select('#' + this.item + newID)
                .transition()
                .duration(500)
                .style('fill', function (d) {
                return 'yellow';
            })
                .style('fill-opacity', 1);
        }
    }
    updateData(data, correction, thr) {
        if (!data) {
            return;
        }
        if (correction !== '') {
            if (!correction) {
                return;
            }
        }
        if (!thr) {
            thr = 0;
        }
        let yLabel, yDisplayLabel;
        if (this.upType) {
            yLabel = this.axisYLabel + this.upType + correction;
            if (this.itemLabel === 'chemicalName') {
                yDisplayLabel =
                    this.axisYLabel +
                        (this.upType === '_p' ? '_pres' : '_abs') +
                        correction;
            }
            else {
                yDisplayLabel =
                    this.axisYLabel +
                        (this.upType === '_p' ? '_act' : '_inh') +
                        correction;
            }
        }
        else {
            yLabel = this.axisYLabel + correction;
            yDisplayLabel = yLabel;
        }
        let xLabel = this.axisXLabel + correction;
        let sigLabel = this.sigLabel + correction;
        let sigThr = thr;
        this.x
            .domain([
            0,
            d3.max(data, function (d) {
                if (d[xLabel]) {
                    return -log10(d[xLabel]);
                }
            }) || -log10(1e-6),
        ])
            .nice();
        this.y
            .domain([
            0,
            d3.max(data, function (d) {
                if (d[yLabel]) {
                    return -log10(d[yLabel]);
                }
            }) || -log10(1e-6),
        ])
            .nice();
        this.pSize.domain(d3.extent(data, (d) => {
            return +d[this.itemSize];
        }));
        // update axes
        this.svg
            .transition()
            .duration(750)
            .select('.x.axis')
            .attr('transform', 'translate(0,' + (this.height + this.axisOffset) + ')')
            .call(this.xAxis)
            .select('.label')
            .attr('x', this.width / 2)
            .attr('y', this.margin.bottom - 2 * this.axisOffset)
            .style('text-anchor', 'middle')
            .style('fill', 'black')
            .text('-log10(' + xLabel + ')');
        this.svg
            .transition()
            .duration(750)
            .select('.y.axis')
            .attr('transform', 'translate(-' + this.axisOffset + ',0)')
            .call(this.yAxis)
            .select('.label')
            .attr('x', -this.height / 2)
            .attr('y', -this.margin.left + this.axisOffset)
            .style('text-anchor', 'middle')
            .style('fill', 'black')
            .text('-log10(' + yDisplayLabel + ')');
        this.svg
            .select('.x.axis')
            .select('.domain')
            .style('fill', 'none')
            .style('stroke', '#000')
            .style('shape-rendering', 'crispEdges');
        this.svg
            .select('.y.axis')
            .select('.domain')
            .style('fill', 'none')
            .style('stroke', '#000')
            .style('shape-rendering', 'crispEdges');
        this.svg
            .select('.x.axis')
            .selectAll('.tick text')
            .style('font-size', '14px')
            .style('font-family', "'Helvetica Neue', Helvetica, Arial, sans-serif");
        this.svg
            .select('.y.axis')
            .selectAll('.tick text')
            .style('font-size', '14px')
            .style('font-family', "'Helvetica Neue', Helvetica, Arial, sans-serif");
        // update the dots
        var allDots = this.svg.selectAll('.dot').data(data, (d) => {
            return d[this.itemId];
        });
        allDots.attr('class', 'update');
        var self = this;
        allDots
            .enter()
            .append('circle')
            .attr('class', 'dot')
            .style('cursor', 'pointer')
            .style('stroke', '#000')
            .style('fill-opacity', '70%')
            .attr('id', (d) => {
            return this.item + d[this.itemId];
        })
            .attr('r', (d) => {
            return this.pSize(d[this.itemSize]);
        })
            .attr('cx', (d) => {
            return this.x(-log10(d[xLabel]));
        })
            .attr('cy', (d) => {
            return d[yLabel] ? this.y(-log10(d[yLabel])) : this.y(-log10(1));
        })
            .on('mouseover', function (event, d) {
            let circle_data = d;
            self.tooltip.text(circle_data[self.itemLabel]);
            self.tooltip.style('visibility', 'visible');
            d3.select(this)
                .transition()
                .duration(100)
                .attr('r', 5 + self.pSize(circle_data[self.itemSize]));
        })
            .on('mousemove', (event) => {
            this.tooltip
                .style('top', event.layerY - 10 + 'px')
                .style('left', event.layerX + 10 + 'px');
        })
            .on('mouseout', function (event, d) {
            let circle_data = d;
            self.tooltip.style('visibility', 'hidden');
            d3.select(this)
                .transition()
                .duration(100)
                .attr('r', self.pSize(circle_data[self.itemSize]));
        })
            .on('click', (event, d) => {
            if (this.disableSelection) {
                this.nextStateFn.emit(d[this.itemId]);
            }
        });
        allDots
            .attr('class', 'dot')
            .attr('r', (d) => {
            return this.pSize(d[this.itemSize]);
        })
            .transition()
            .duration(750)
            .attr('cy', (d) => {
            return d[yLabel] ? this.y(-log10(d[yLabel])) : this.y(-log10(1));
        })
            .attr('cx', (d) => {
            return this.x(-log10(d[xLabel]));
        })
            .style('fill', (d) => {
            if (this.selectedItem) {
                if (Number(this.selectedItem) === d[this.itemId]) {
                    return 'yellow';
                }
            }
            return d[sigLabel]
                ? this.color(d[sigLabel] < sigThr)
                : this.color(d[xLabel] < sigThr);
        });
        // update thresholds
        //
        this.svg
            .select('.x.thr')
            .attr('x1', this.x(-log10(sigThr)))
            .attr('y1', this.y.range()[0])
            .attr('x2', this.x(-log10(sigThr)))
            .attr('y2', this.y.range()[0])
            .transition()
            .duration(750)
            .style('stroke-opacity', 1)
            .attr('y2', this.y.range()[1]);
        this.svg
            .select('.y.thr')
            .attr('x1', this.x.range()[0])
            .attr('y1', this.y(-log10(sigThr)))
            .attr('x2', this.x.range()[0])
            .attr('y2', this.y(-log10(sigThr)))
            .transition()
            .duration(750)
            .style('stroke-opacity', 1)
            .attr('x2', this.x.range()[1]);
        allDots.exit().remove();
        // end update dots
    }
}
TwoWayPlotDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.7", ngImport: i0, type: TwoWayPlotDirective, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive });
TwoWayPlotDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "13.2.7", type: TwoWayPlotDirective, selector: "[twoWayPlot]", inputs: { data: "data", correction: "correction", upType: "upType", sigThr: "sigThr", selectedItem: "selectedItem", disableSelection: "disableSelection", axisXLabel: "axisXLabel", axisYLabel: "axisYLabel", numTicks: "numTicks", sigLabel: "sigLabel", itemLabel: "itemLabel", itemSize: "itemSize", itemId: "itemId", item: "item", itemScale: "itemScale", showXThreshold: "showXThreshold", showYThreshold: "showYThreshold" }, outputs: { nextStateFn: "nextStateFn" }, host: { listeners: { "window:resize": "onResize($event)" } }, usesOnChanges: true, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.7", ngImport: i0, type: TwoWayPlotDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[twoWayPlot]',
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; }, propDecorators: { data: [{
                type: Input
            }], correction: [{
                type: Input
            }], upType: [{
                type: Input
            }], sigThr: [{
                type: Input
            }], selectedItem: [{
                type: Input
            }], disableSelection: [{
                type: Input
            }], axisXLabel: [{
                type: Input
            }], axisYLabel: [{
                type: Input
            }], numTicks: [{
                type: Input
            }], sigLabel: [{
                type: Input
            }], itemLabel: [{
                type: Input
            }], itemSize: [{
                type: Input
            }], itemId: [{
                type: Input
            }], item: [{
                type: Input
            }], nextStateFn: [{
                type: Output
            }], itemScale: [{
                type: Input
            }], showXThreshold: [{
                type: Input
            }], showYThreshold: [{
                type: Input
            }], onResize: [{
                type: HostListener,
                args: ['window:resize', ['$event']]
            }] } });

class D3PlotModule {
}
D3PlotModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.7", ngImport: i0, type: D3PlotModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
D3PlotModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.2.7", ngImport: i0, type: D3PlotModule, declarations: [TwoWayPlotDirective], exports: [TwoWayPlotDirective] });
D3PlotModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.2.7", ngImport: i0, type: D3PlotModule, imports: [[]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.7", ngImport: i0, type: D3PlotModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [TwoWayPlotDirective],
                    imports: [],
                    exports: [TwoWayPlotDirective],
                }]
        }] });

/*
 * Public API Surface of d3-plot
 */

/**
 * Generated bundle index. Do not edit.
 */

export { D3PlotModule, TwoWayPlotDirective };
//# sourceMappingURL=d3-plot.mjs.map
